package com.diagbot.rule;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;

import java.util.List;

/**
 * @description: 化验规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class LisRule {

    /**
     * 比较化验
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public static void compareLisWithBill(List<Lis> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getLis();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Lis lis : inputLis) {
                    String val = lis.getUniqueName();
                    if (StringUtil.isNotBlank(val) && val.equals(neo.getName())) {
                        String val_name = lis.getDetailName();
                        // 如果有结果数据，就不用比较数值
                        String message = "";
                        boolean flag = false;
                        String otherValue = lis.getOtherValue();
                        if (StringUtil.isNotBlank(otherValue)) {
                            flag = CoreUtil.compareStr(neo, otherValue);
                            if (flag) {
                                // message = CoreUtil.getStrMsg(neo, val_name, lis.getResult());
                                message = lis.getName() + val_name + otherValue;
                            }
                        } else if (lis.getValue() != null) {
                            flag = CoreUtil.compareNum(neo, lis.getValue());
                            if (flag) {
                                // message = CoreUtil.getNumMsg(neo, val_name, lis.getValue(), lis.getUnits());
                                message = lis.getName() + val_name + lis.getValue();
                            }
                        }
                        if (flag) {
                            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                                    billNeoMaxDTO.getOrderStandName(), message, message, type);
                            billMsgList.add(commonBillMsg);
                        }
                    }
                }
            }
        }
    }
}
